import App 
import MissionLib 
import Libs.LibEngineering
import Foundation
import Custom.NanoFXv2.NanoFX_Lib
import string
import Conditions.ConditionFiringTractorBeam

pPlugin1 = None
pMenu = None 
pStatus = None 
pFire = None 
pFireFleet = None 
pImpulse= None 
pCharge = None
pCharge1 = None

GFX = 'scripts/Custom/QBautostart/EngOverloadData/' 

def init():
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()

        # When you change a player ship then initiate the script
        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".ShipCheck")

def ChargingOverloadTarget(pObject, pEvent): 
	pCharge.SetDisabled()
	pCharge1.SetDisabled()
	pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	pStatus.SetName(App.TGString("Status: Charging.."))
        Sound = App.TGSound_Create("sfx/Custom/EngOverload/CodesVerified.mp3", "LockedOn", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("LockedOn")
	#CHARGING TIME FOR TARGET WEPON
        DelayValue = 30
        MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableFireTarget", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0)
        OverloadTargetDrain(None, None)

def ChargingOverloadFleet(pObject, pEvent): 
	pCharge.SetDisabled()
	pCharge1.SetDisabled()
	pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	pStatus.SetName(App.TGString("Status: Charging.."))
        Sound = App.TGSound_Create("sfx/Custom/EngOverload/CodesVerified.mp3", "LockedOn", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("LockedOn")
	pStatus.SetName(App.TGString("Status: Charging.."))
	#CHARGING TIME FOR FLEET WEPON
	OverloadTargetDrain(None, None)
        DelayValue = 40
        MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableFireFleet", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0) 

#allow fireing of Overload Wave  
def EnableFireTarget(pObject, pEvent): 
        global pFire, pFireFleet, ChargeValue
        pFire.SetEnabled()
	pFireFleet.SetDisabled()
	ChargeValue = 1
	pStatus.SetName(App.TGString("Status: Charged"))
        Sound = App.TGSound_Create("sfx/Custom/EngOverload/LockedOn.mp3", "LockedOn", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("LockedOn")


def EnableFireFleet(pObject, pEvent): 
        global pFire, pFireFleet, ChargeValue, pFired
        Sound = App.TGSound_Create("sfx/Custom/EngOverload/LockedOn.mp3", "LockedOn", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("LockedOn")
        pFire.SetDisabled()
        pCharge.SetDisabled()
        pCharge1.SetDisabled()
	pFireFleet.SetEnabled()
	pStatus.SetName(App.TGString("Status: Charged"))

#Fire Overload Wave 
def OverloadTarget(pObject, pEvent): 
        global pMenu, pStatus, pFire, pTargetattr, pTarget, pFireFleet, pFired
	pPlayer = MissionLib.GetPlayer() 
	pTarget = pPlayer.GetTarget() 
	pTargetattr = App.ShipClass_Cast(pTarget) 
	pTargetName = pTarget.GetName() 
	pGame = App.Game_GetCurrentGame() 
	pEpisode = pGame.GetCurrentEpisode() 
	pMission = pEpisode.GetCurrentMission() 
	pEnemy = pMission.GetEnemyGroup() 
	pTractor = pPlayer.GetTractorBeamSystem()
	if (pTractor):
            if DistanceCheck2(pTarget) > 120:
                Sound = App.TGSound_Create("sfx/Custom/EngOverload/OutOfRange.wav", "LockedOn", 0)
                Sound.SetSFX(0)
                Sound.SetInterface(1)
                App.g_kSoundManager.PlaySound("LockedOn")
            else:
                pStatus.SetName(App.TGString("Status: Firing"))                  
                if not pTarget:
                        pStatus.SetName(App.TGString("Status: Stand By"))
                        return 

                if (pEnemy.IsNameInGroup(pTargetName) != 1):
                        pStatus.SetName(App.TGString("Status: Stand By"))
                        return
                
                pImpulse = pTargetattr.GetImpulseEngineSubsystem() 

                if pImpulse:
                        pImpulse.GetProperty().SetDisabledPercentage(100.0) 
                        pFire.SetDisabled() 
                        pFireFleet.SetDisabled()
                            
                pStatus.SetName(App.TGString("Status: Fired"))
                #TIME THAT THE TARGET ENGINES ARE DISABLED
                DelayValue = 40
                InitiateTractor(None, None)
                MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableTargetImpulse", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0) 

#Fire Overload Wave At Fleet
def OverloadFleet(pObject, pEvent): 
        global pMenu, pStatus, pFire, pTargetattr, pTarget, pFireFleet
	pPlayer = MissionLib.GetPlayer() 
	pTarget = pPlayer.GetTarget() 
	pSet = pPlayer.GetContainingSet()
	pGame = App.Game_GetCurrentGame() 
	pEpisode = pGame.GetCurrentEpisode() 
	pMission = pEpisode.GetCurrentMission() 
	pEnemy = pMission.GetEnemyGroup() 
	lpEnemies = pEnemy.GetActiveObjectTupleInSet(pSet)   
	
        for pEnemy in lpEnemies:
                pShip = App.ShipClass_GetObject(pSet, pEnemy.GetName())
                if DistanceCheck2(pShip) < 120:
                    pTargetattr	= App.ShipClass_Cast(pEnemy)
                    if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
                            pImpulse = pTargetattr.GetImpulseEngineSubsystem() 
                            if pImpulse: 
                                    pImpulse.GetProperty().SetDisabledPercentage(100.0) 
	
	#TIME THAT THE FLEET ENGENS ARE DISABLED
	DelayValue = 40
	pTimer1 = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableFleetImpulse", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0) 
	pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	pStatus.SetName(App.TGString("Status: Fired"))
	InitiateWaveSeq(None, None)

#Reenable target's engine 
def EnableTargetImpulse(pObject, pEvent): 
	global pFire, pStatus, pTargetattr, pTarget, pFireFleet
	pStatus.SetName(App.TGString("Status: Offline"))
	pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	ChargeValue = 0
	pImpulse = pTargetattr.GetImpulseEngineSubsystem() 
	pImpulse.GetProperty().SetDisabledPercentage(0.0) 
	#TIME BEFORE WEPON BECOMES AVALABLE (TARGET)
	DelayValue = 30
	pTimer1 = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".ResetOverload", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0) 

#Reenable Fleet's engine #Dont Know if This will work
def EnableFleetImpulse(pObject, pEvent): 
	global pMenu, pStatus, pFire, pTargetattr, pTarget, pFireFleet
	pPlayer = MissionLib.GetPlayer() 
	pTarget = pPlayer.GetTarget() 
	pSet = pPlayer.GetContainingSet()
	pGame = App.Game_GetCurrentGame() 
	pEpisode = pGame.GetCurrentEpisode() 
	pMission = pEpisode.GetCurrentMission() 
	pEnemy = pMission.GetEnemyGroup() 
	lpEnemies = pEnemy.GetActiveObjectTupleInSet(pSet)
	
	#some edits which i dont realy know if it will work
        for pEnemy in lpEnemies:
		pTargetattr	= App.ShipClass_Cast(pEnemy)
		if (str(pTargetattr) != str(App.ShipClass_Cast(pPlayer))):
			pImpulse = pTargetattr.GetImpulseEngineSubsystem()
			if pImpulse:
                            pImpulse.GetProperty().SetDisabledPercentage(0.0) 
	
	pStatus.SetName(App.TGString("Status: Offline"))
	pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	#TIME BEFORE WEPON BECOMES AVALABLE (FLEET)
	DelayValue = 30
	pTimer1 = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".ResetOverload", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0) 

#Reset Overload 
def ResetOverload(pObject, pEvent): 
	global pStatus, pFire, pFireFleet, ChargeValue, pCharge, pCharge1
        pCharge.SetEnabled()
        pCharge1.SetEnabled()
        pFire.SetDisabled() 
	pFireFleet.SetDisabled()
	ChargeValue = 0
	pFired = 0
	pStatus.SetName(App.TGString("Status: Stand By"))

# Initiating GFX and all other sequences
def StartSeq():
        Initiate()
        PlayWaveSound(None, None)

# Initiate Tractor Sequence
def InitiateTractor(pObject, pEvent):
	global pFire, pCharge
        # Create a pretty cutscene and turn on NanoFX flickering
        pPlayer = MissionLib.GetPlayer()
	pTarget = pPlayer.GetTarget()
	pTractor = pPlayer.GetTractorBeamSystem()
	pTractor.StopFiring()
        pSequence = App.TGSequence_Create ()
	pSequence.AppendAction(MissionLib.OrientObjectTowardObject(pPlayer, pTarget))
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "StartCutscene"))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pPlayer.GetContainingSet().GetName ()))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pPlayer.GetContainingSet().GetName(), pPlayer.GetName(), 350, 10, 25))
        pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "Off"), App.TGAction_CreateNull(), 1.0)
	pSequence.Play()
	
	#set the tractor to tow so that the target is stationary in relation to player
	pTractor.SetMode(pTractor.TBS_HOLD)
	pTractor.StartFiring(pTarget)
	
	MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".SeqTarget1", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

def SeqTarget1(pObject, pEvent):
	global pFire, pCharge
        # Create a pretty cutscene and turn on NanoFX flickering
        pPlayer = MissionLib.GetPlayer()
	pTarget = pPlayer.GetTarget()
	pTractor = pPlayer.GetTractorBeamSystem()
	pTractor.StartFiring(pTarget)
        pSequence = App.TGSequence_Create ()
	pSequence.AppendAction(MissionLib.OrientObjectTowardObject(pTarget, pTarget))
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "StartCutscene"))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pTarget.GetContainingSet().GetName ()))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pTarget.GetContainingSet().GetName(), pTarget.GetName(), 350, 10, 25))
	pSequence.Play()
	pTractor.StartFiring(pTarget)
	 
	MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EndSeqTarget", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

# Ending Sequence (Target Version)
def EndSeqTarget(pObject, pEvent):
        # End the cutscene and turn on ship lights
        pPlayer = MissionLib.GetPlayer()
	pTractor = pPlayer.GetTractorBeamSystem()
	pTractor.StopFiring()
        pSequence = App.TGSequence_Create ()
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "StartCutscene"))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pPlayer.GetContainingSet().GetName ()))
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pPlayer.GetContainingSet().GetName(), pPlayer.GetName(), 350, 10, 25))
        pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "On"), App.TGAction_CreateNull(), 1.0)
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pPlayer.GetContainingSet().GetName ()))
        # Switch to bridge view
        if App.g_kSetManager.GetSet("bridge"):
                 pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge")
                 pSequence.AppendAction(pAction)
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "EndCutscene"))
        pSequence.Play()

# Initiate Wave Sequence
def InitiateWaveSeq(pObject, pEvent):
         global pFire, pCharge
         # Create a pretty cutscene and turn on NanoFX flickering
         pPlayer = MissionLib.GetPlayer()
         pSequence = App.TGSequence_Create ()
         pSequence.AppendAction (App.TGScriptAction_Create("MissionLib", "StartCutscene"))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pPlayer.GetContainingSet().GetName ()))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pPlayer.GetContainingSet().GetName(), pPlayer.GetName(), 350, 10, 25))
         pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "Off"), App.TGAction_CreateNull(), 1.0)
         pSequence.Play()

         # Go to the next function
         MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".InitiateWaveSeq2", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

# Wave seq part 2
def InitiateWaveSeq2(pObject, pEvent):
         SetPlayerImpulse(None, None)
         pSequence = App.TGSequence_Create ()
         # Initiate the GFX sequence
         pSequence.AppendAction(StartSeq(), 1.0)

         MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EndSeq", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

# Ending Sequence
def EndSeq(pObject, pEvent):
        # End the cutscene and turn on ship lights
        pPlayer = MissionLib.GetPlayer()
        pSequence = App.TGSequence_Create ()
        pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "On"), App.TGAction_CreateNull(), 1.0)
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pPlayer.GetContainingSet().GetName ()))
        # Switch to bridge view
        if App.g_kSetManager.GetSet("bridge"):
                 pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge")
                 pSequence.AppendAction(pAction)
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "EndCutscene"))
        pSequence.Play()

# Setting Impulse power to 0
def SetPlayerImpulse(pObject, pEvent):
                pPlayer = MissionLib.GetPlayer()
                pPlayer.SetSpeed(0, App.TGPoint3_GetModelForward(), App.PhysicsObjectClass.DIRECTION_MODEL_SPACE)

                return
            
# Setting Impulse power to 0
def SetTargetImpulse(pTarget):
                #global pTargetattr
                #pImpulse = pTargetattr.GetImpulseEngineSubsystem()
                #pImpulse.SetSpeed(0, App.TGPoint3_GetModelForward(), App.PhysicsObjectClass.DIRECTION_MODEL_SPACE)
		pTarget.SetSpeed(0, App.TGPoint3_GetModelForward(), App.PhysicsObjectClass.DIRECTION_MODEL_SPACE)
                return

# Play the wave sound
def PlayWaveSound(pObject, pEvent):
        Sound = App.TGSound_Create("sfx/Custom/EngOverload/WaveSFX.mp3", "WaveSFX", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("WaveSFX")

# Just a simple distance check
def DistanceCheck2(pObject):
	pPlayer = App.Game_GetCurrentGame().GetPlayer()
	vDifference = pObject.GetWorldLocation()
	vDifference.Subtract(pPlayer.GetWorldLocation())

	return vDifference.Length()

# Load the GFX
def StartGFX():
                LoadGfx(8,2,GFX)

# Create these textures on the ship
def CreateGFX():
	global fRed, fBlue, fGreen
        # First basic stuff we define where where from we'll emmit those textures etc.
        pPlayer = MissionLib.GetPlayer()
	pAttachTo = pPlayer.GetNode()
	fSize     = 25
	pSequence = App.TGSequence_Create()	
	pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
	pPlugin = GetShipType(pPlayer)
	pModule = __import__("Custom.QBautostart.EngOverloadPlugins." + pPlugin)
	#Check if there are coulor modules if not load defults
	if hasattr(pModule, "fRed"):
		fRed = pModule.fRed()
	else:
		fRed = 131.0
		
	if hasattr(pModule, "fBlue"):
		fBlue = pModule.fBlue()
	else:
		fBlue = 225.0
		
	if hasattr(pModule, "fGreen"):
		fGreen = pModule.fGreen()
	else:
		fGreen = 80.0
		
	# Setup some needed values	
	sFile = ChooseRandomTexture()
	iTiming = 15.0
	fLifeTime = 1
	fBrightness = 0.8
	fSpeed = iTiming / 15.0
	# We start creating the effect, also very similar to the code from effects.py                
	pEffect = App.AnimTSParticleController_Create()
	pEffect.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
	pEffect.AddColorKey(1.0, fRed / 255, fGreen / 255, fBlue / 255)
	pEffect.AddAlphaKey(0.0, 1.0)
	pEffect.AddAlphaKey(1.0, 1.0)
	pEffect.AddSizeKey(0.0, fSize)
	pEffect.AddSizeKey(1.0, fSize)
	
	pEffect.SetEmitLife(fSpeed)
	pEffect.SetEmitFrequency(1)
	pEffect.SetEffectLifeTime(fSpeed + fLifeTime)
	pEffect.SetInheritsVelocity(0)
	pEffect.SetDetachEmitObject(0)
	pEffect.CreateTarget(sFile)
	pEffect.SetTargetAlphaBlendModes(0, 7)
	pEffect.SetEmitFromObject(pEmitFrom)
	pEffect.AttachEffect(pAttachTo)                
	Effect = App.EffectAction_Create(pEffect)
	pSequence.AddAction(Effect)
	pSequence.Play ()
                
	return

# Support for multiple textures, thanks LJ ;)
def ChooseRandomTexture():
                iRandom = App.g_kSystemWrapper.GetRandomNumber(len(Foundation.GetFileNames(GFX, 'tga')))
                strFile = GFX + "Wave" + str(iRandom) + ".tga"
                
                return strFile

# Load textures
def LoadGfx(iNumXFrames, iNumYFrames, Folder):
                FileNames = Foundation.GetFileNames(Folder, 'tga')       

                for loadIndex in FileNames:
                        strFile = Folder + str(loadIndex)
                        fX = 0.0
                        fY = 0.0

                        pContainer = App.g_kTextureAnimManager.AddContainer(strFile)   
                        pTrack = pContainer.AddTextureTrack(iNumXFrames * iNumYFrames)
                        for index in range(iNumXFrames * iNumYFrames):
                                pTrack.SetFrame(index, fX, fY + (1.0 / iNumYFrames), fX + (1.0 / iNumXFrames), fY)
                                fX = fX + (1.0 / iNumXFrames)

                                if (fX == 1.0):
                                        fX = 0.0
                                        fY = fY + (1.0 / iNumYFrames)

                
# We call this upper in the script and it calls all relevant data to create a texture
def Initiate():
                StartGFX()
                for i in range(1):
                    CreateGFX()

def OverloadTargetDrain(pObject, pEvent): 
       pPlayer          = MissionLib.GetPlayer() 
       pWarpCore        = pPlayer.GetPowerSubsystem() 
       pPower           = pPlayer.GetPowerSubsystem() 
       CoreStatus       = pWarpCore.GetCondition() 
       DisabledPercent  = pWarpCore.GetDisabledPercentage() 

        
       if not pWarpCore: 
              print "Stupid people! Not adding warp cores to your ships. What is this world coming to?" 
              return 
                
       if pWarpCore: 
                # This checks to make sure that the Core isn't offline 
                if CoreStatus <= DisabledPercent: 
                        print "Failure to comply. Warp Core is offline." 
                        return 

                if CoreStatus > DisabledPercent: 
                        #print "ACO: Overload Successful!" 
                        CoreStatus = pWarpCore.GetCondition() 
                        CoreMaxStatus = pWarpCore.GetMaxCondition() 
                        MainPower = pPower.GetMainBatteryPower() 
                        BatteryPower = pPower.GetBackupBatteryPower() 
                        MaxMainPower = pPower.GetMainBatteryLimit() 
                        MaxBatteryPower = pPower.GetBackupBatteryLimit() 
                        DisabledPercent = pWarpCore.GetDisabledPercentage() 

                        if MainPower > MaxMainPower:
                                print "ACO: You've got some power problems, pallie."
                                return

                        # Do your stuff, script. 
                        pPower.SetMainBatteryPower(MainPower - (MaxMainPower/15)) #subtracts 5% power from the main battery 
                        print "Power Drain Successful!"

def OverloadFleetDrain(pObject, pEvent): 
       pPlayer          = MissionLib.GetPlayer() 
       pWarpCore        = pPlayer.GetPowerSubsystem() 
       pPower           = pPlayer.GetPowerSubsystem() 
       CoreStatus       = pWarpCore.GetCondition() 
       DisabledPercent  = pWarpCore.GetDisabledPercentage() 

        
       if not pWarpCore: 
              print "Stupid people! Not adding warp cores to your ships. What is this world coming to?" 
              return 
                
       if pWarpCore: 
                # This checks to make sure that the Core isn't offline 
                if CoreStatus <= DisabledPercent: 
                        print "Failure to comply. Warp Core is offline." 
                        return 

                if CoreStatus > DisabledPercent: 
                        #print "ACO: Overload Successful!" 
                        CoreStatus = pWarpCore.GetCondition() 
                        CoreMaxStatus = pWarpCore.GetMaxCondition() 
                        MainPower = pPower.GetMainBatteryPower() 
                        MaxMainPower = pPower.GetMainBatteryLimit() 
                        DisabledPercent = pWarpCore.GetDisabledPercentage() 

                        if MainPower > MaxMainPower:
                                print "ACO: You've got some power problems, pallie."
                                return

                        # Do your stuff, script. 
                        pPower.SetMainBatteryPower(MainPower - (MaxMainPower/10)) #subtracts 5% power from the main battery 
                        print "Power Drain Successful!"


# We check to make sure that we're using the right ship over here
def ShipCheck(pObject, pEvent):
        global pPlugin
        
        # Grab some values
        pPlayer = MissionLib.GetPlayer()

        # We don't want duplicate menus now, do we?!
        RemoveMenu()

        # Get the currently used ship HP
        pPlugin = None

        pPlugin = GetShipType(pPlayer)

        
        # Hmm... this ship has a plugin so load it and check if it's OK!
        try:

            # Import the module
            pModule = __import__("Custom.QBautostart.EngOverloadPlugins." + pPlugin)

            # Check module properties
            if hasattr(pModule, "SHIP_HARDPOINT_NAME"):

                # All is ok, retrieve the value
                HPName = pModule.SHIP_HARDPOINT_NAME()

                # One final check before we add the menu
                if pPlugin == HPName:
                    # All is well build the menu
                    BuildMenu()

                # Give a console printout of an unsuccessfull Plugin Loading
                else:
                    print "PhalWave:", HPName, "plugin is invalid! Please consult the Readme for more info or contact BCS: TNG"        

            else:
                    # Also warn the user that something went wrong!
                    print "PhalWave:", HPName, "plugin is invalid! Please consult the Readme for more info or contact BCS: TNG" 

        # No plugins we won't do anything
        except:
            
            return
            

# Building a menu
def BuildMenu():
        global pMenu, pStatus, pFire, pFireFleet, pCharge, pCharge1

        # Make me a menu 
        pBridge = App.g_kSetManager.GetSet('bridge') 
	pScienceMenu = Libs.LibEngineering.GetBridgeMenu("Tactical") 
	pMenu = App.STMenu_CreateW(App.TGString("Overload Impulse")) 
	pScienceMenu.PrependChild(pMenu)
	pMenu1 = App.STMenu_CreateW(App.TGString("Fleet.."))
	pMenu.PrependChild(pMenu1)
	pMenu2 = App.STMenu_CreateW(App.TGString("Ship.."))
	pMenu.PrependChild(pMenu2)
	
	# Setup buttons 
	pCharge = Libs.LibEngineering.CreateMenuButton("Charge Pulse", "Tactical", __name__ + ".ChargingOverloadTarget", 0, pMenu2)
	pCharge1 = Libs.LibEngineering.CreateMenuButton("Charge Pulse", "Tactical", __name__ + ".ChargingOverloadFleet", 0, pMenu1)
	pFireFleet = Libs.LibEngineering.CreateMenuButton("Fire", "Tactical", __name__ + ".OverloadFleet", 0, pMenu1)
	pFire = Libs.LibEngineering.CreateMenuButton("Fire", "Tactical", __name__ + ".OverloadTarget", 0, pMenu2) 
        pStatus = Libs.LibEngineering.CreateMenuButton("Status: Stand By", "Tactical", __name__ + ".Nothing", 0, pMenu) 

        # Disable some options 
        pCharge.SetEnabled()
        pCharge1.SetEnabled() 
        pFire.SetDisabled() 
	pFireFleet.SetDisabled()

def RemoveMenu():
        g_pDatabase = App.g_kLocalizationManager.Load("data/TGL/OverloadImpulse.tgl")
        pBridge = App.g_kSetManager.GetSet("bridge")
        g_pPerson = App.CharacterClass_GetObject(pBridge, "Tactical")
        pMenu = g_pPerson.GetMenu()
	if (pMenu != None):
		pButton = pMenu.GetSubmenu("Overload Impulse")
		if (pButton != None):
			pMenu.DeleteChild(pButton)

# It returns currently used Ship HP, needed for plugin checking
def GetShipType(pShip):
                if pShip.GetScript():
                        return string.split(pShip.GetScript(), '.')[-1]
                return None
